<?php
 class mod_impexp extends mod_basic { var $name = "CSV Export"; var $desc = "Erlaubt das importieren und exportieren der Produkttabellen über CSV Dateien."; var $lizenz = 1; var $id = 105; function ProduktExport() { $arProdukte = $this->controller->db->fetchAssoc("
				SELECT
					P.*,
					MW.value AS mwst_value 	 
				FROM
					`".$this->controller->tbl_pr."` AS P
						LEFT JOIN `".$this->controller->tbl_mw."` AS MW ON (P.mwst = MW.id)
				WHERE
					P.`deleted` != '1' 			
			"); $arExport = array(); foreach ($arProdukte as $p) { $p['v_id'] = 0; $vari = false; if (array_key_exists("mod_varianten", $this->controller->mods)) { $vari = $this->controller->db->fetchAssoc("
						SELECT
							*
						FROM
							`".$this->controller->tbl_vr."`
						WHERE
							`p_id` = '".wpsg_q($p['id'])."'
					"); if (sizeof($vari) > 0) { $add_p = Array( "id" => $p['id'], "v_id" => 0, "name" => $p['name'], "anr" => $p['anr'], "typ" => $p['typ'], "partikel" => $p['partikel'], "preis" => $p['preis'], "mwst" => $p['mwst'], "feinheit" => $p['feinheit'], "fmenge" => $p['fmenge'], "beschreibung" => $p['beschreibung'], "pgruppe" => $p['pgruppe'], "ptemplate_file" => $p['ptemplate_file'], "weight" => $p['weight'], "stock" => $p['stock'], "stock_count" => $p['stock_count'], "deleted" => $p['deleted'], "lang_parent" => $p['lang_parent'], "lang_locale" => $p['lang_locale'], "rabatt" => $p['rabatt'] ); if (array_key_exists("mod_attribute", $this->controller->mods)) { $att = $this->controller->db->fetchAssoc("SELECT * FROM `".$this->controller->tbl_at."`"); foreach ($att as $a) { $add_p["ATT_".$a['name']] = $this->controller->db->fetchOne("SELECT `value` FROM `".$this->controller->tbl_pa."` WHERE `p_id` = '".wpsg_q($p['id'])."' AND `a_id` = '".wpsg_q($a['id'])."' "); } } $arExport[] = $add_p; foreach ($vari as $v) { $arExport[] = Array( "id" => $p['id'], "v_id" => $v['id'], "name" => $v['name'], "anr" => $p['anr'], "typ" => $p['typ'], "partikel" => $p['partikel'], "preis" => $v['preis'], "mwst" => $p['mwst'], "feinheit" => $p['feinheit'], "fmenge" => $p['fmenge'], "beschreibung" => $p['beschreibung'], "pgruppe" => $p['pgruppe'], "ptemplate" => $p['template'], "weight" => $v['weight'], "stock" => $v['stock'], "stock_count" => $p['stock_count'], "deleted" => $v['deleted'], "lang_parent" => $p['lang_parent'], "lang_locale" => $p['lang_locale'], "rabatt" => $p['rabatt'] ); } $vari = true; } } if (!$vari) { $add_p = Array( "id" => $p['id'], "v_id" => 0, "name" => $p['name'], "anr" => $p['anr'], "typ" => $p['typ'], "partikel" => $p['partikel'], "preis" => $p['preis'], "mwst" => $p['mwst'], "feinheit" => $p['feinheit'], "fmenge" => $p['fmenge'], "beschreibung" => $p['beschreibung'], "pgruppe" => $p['pgruppe'], "ptemplate" => $p['template'], "weight" => $p['weight'], "stock" => $p['stock'], "stock_count" => $p['stock_count'], "deleted" => $p['deleted'], "lang_parent" => $p['lang_parent'], "lang_locale" => $p['lang_locale'], "rabatt" => $p['rabatt'] ); if (array_key_exists("mod_attribute", $this->controller->mods)) { $att = $this->controller->db->fetchAssoc("SELECT * FROM `".$this->controller->tbl_at."`"); foreach ($att as $a) { $add_p["ATT_".$a['name']] = $this->controller->db->fetchOne("SELECT `value` FROM `".$this->controller->tbl_pa."` WHERE `p_id` = '".wpsg_q($p['id'])."' AND `a_id` = '".wpsg_q($a['id'])."' "); } } $arExport[] = $add_p; } } if (!file_exists(WP_CONTENT_DIR.'/uploads/')) mkdir(WP_CONTENT_DIR.'/uploads/'); $fp = fopen(WP_CONTENT_DIR.'/uploads/wpshopgermany_export.csv', 'w'); fputcsv($fp, array_keys($arExport[0]));; foreach ($arExport as $e) { fputcsv($fp, $e, ',', '"'); } fclose($fp); header('Content-type: application/download'); header('Content-Disposition: inline; filename="wpshopgermany_export.csv"'); header('Expires: 0'); header('Cache-Control: must-revalidate, post-check=0, pre-check=0'); header('Pragma: public'); readfile(WP_CONTENT_DIR.'/uploads/wpshopgermany_export.csv'); die(); } function ProduktImport() { if (isset($_FILES['datei'])) { $nImported = 0; $keys = array(); $handle = fopen($_FILES['datei']['tmp_name'], "r"); while (($row = fgetcsv ($handle, 100000, ",")) !== FALSE ) { if (is_numeric($row[0])) { $data = array(); foreach ($keys as $k => $k_name) { $data[$k_name] = $row[$k]; } if ($data['v_id'] == 0) { $this->controller->db->Query("DELETE FROM `".$this->controller->tbl_pr."` WHERE `id` = '".wpsg_q($data['id'])."'"); if (array_key_exists("mod_varianten", $this->controller->mods)) $this->controller->db->Query("DELETE FROM `".$this->controller->tbl_vr."` WHERE `p_id` = '".wpsg_q($data['id'])."'"); if (array_key_exists("mod_attribute", $this->controller->mods)) $this->controller->db->Query("DELETE FROM `".$this->controller->tbl_pa."` WHERE `p_id` = '".wpsg_q($data['id'])."'"); $nImported ++; unset($data['v_id']); unset($data['mwst_value']); unset($data['ptemplate']); $data_import = $data; foreach ($data_import as $k => $v) { if (preg_match("/^ATT_(.*)/", $k)) { unset($data_import[$k]); } } $pNeu_id = $this->controller->db->importQuery($this->controller->tbl_pr, $data_import); foreach ($data as $k => $v) { if (preg_match("/^ATT_(.*)/", $k)) { $att_id = $this->controller->db->fetchOne("SELECT `id` FROM `".$this->controller->tbl_at."` WHERE `name` = '".wpsg_q(preg_replace("/^ATT_/", "", $k))."' "); $this->controller->db->ImportQuery($this->controller->tbl_pa, array( "p_id" => wpsg_q($pNeu_id), "a_id" => wpsg_q($att_id), "value" => wpsg_q($v) )); } } } else { if (array_key_exists("mod_varianten", $this->controller->mods)) { $data_vr = array(); $data_vr['p_id'] = $data['id']; $data_vr['preis'] = $data['preis']; $data_vr['name'] = $data['name']; if (array_key_exists("mod_weight", $this->controller->mods)) $data_vr['weight'] = $data['weight']; $this->controller->db->importQuery($this->controller->tbl_vr, $data_vr); } } } else { $keys = $row; } } fclose($handle); $this->controller->strMeldung = $nImported." Produkte importiert."; $this->controller->actionName = "index"; $this->controller->indexAction(); return; } echo '
				<h2>Produktimport</h2>
				<p>
					<i>Hier können Sie exportierte Produktlisten wieder importieren. Beachten Sie das eventuell bestehende Produkte vorher gelöscht werden.</i>
					<br /><br />
					<i>Produktbilder und Produktdownloads müssen in folgende Ordnerstruktur kopiert werden:<br /><br /></i>
					"\wp-content\uploads\produktbilder\{produkt_id}\ und \wp-content\uploads\produktbilder\{produkt_id}\tn"<br />
					und<br />
					"\wp-content\uploads\produktfiles\{produkt_id}\"<br />
					<br />
					<i>{produkt_id} ist dabei die jeweilige Produktnummer<br /></i>		
					<b>Hinweise:</b>
					<ul>
						<li>Die Spalte "MwSt" im Im- und Export zeigt auf die ID des Mehrwertsteuersatzes in der Datenbank.</li>			
					</ul>
				</p>
				
				<form method="post" enctype="multipart/form-data">
					<input type="file" name="datei"><br />
					<br />
					<input type="submit" value="Hochladen">
				</form>
				<br /><hr/><br />
				<a href="'.SITECOOKIEPATH.'wp-admin/admin.php?page=wpshopgermany-Produkt">Zurück zur Produktübersicht</a>
				
			'; } } ?>