<?php
 class mod_rabatt extends mod_basic { var $id = 700; var $desc = "Ist dieses Modul aktiv, so lassen sich Rabatte abhängig vom Bestellwert vergeben. Der Bestellwert ist der Artikelpreis + Kosten für Versandkosten etc."; var $group = 'Bestellung'; var $name = "Rabatt"; var $lizenz = 1; public function settings_save() { $data_rabatt = $this->getOptionData(); $data_rabatt[0]['rabatt'] = $this->clear($_REQUEST['value'][0]['rabatt']); if ($_REQUEST['neu']['value'] > 0 && $_REQUEST['neu']['rabatt'] > 0) { $data = array( "value" => $this->clear($_REQUEST['neu']['value']), "rabatt" => $this->clear($_REQUEST['neu']['rabatt']) ); $find = false; foreach ($data_rabatt as $k => $v) { if ($v['value'] == $data['value']) $find = $k; } if ($find !== false) $data_rabatt[$find] = $data; else $data_rabatt[] = $data; $insert = $this->clear($_REQUEST['neu']['value']); $_REQUEST['neu']['value'] = ""; $_REQUEST['neu']['rabatt'] = ""; } else if ($_REQUEST['neu']['value'] > 0 || $_REQUEST['neu']['rabatt'] > 0) { $this->controller->strError = __("Bitte einen gültigen Bestellwert und einen Rabatt eingeben!", "wpsg"); } foreach ($_REQUEST['value'] as $k => $v) { $find = false; foreach ($data_rabatt as $k2 => $v2) { if ( $this->clear($v2['value']) == $this->clear($v['value']) && $this->clear($v2['value']) != $insert ) $find = $k2; } if ($find !== false) { if ($v['del'] == 1) unset($data_rabatt[$find]); else $data_rabatt[$find]['rabatt'] = $this->clear($v['rabatt']); } } update_option("wpsg_rabatt_data", serialize($data_rabatt)); update_option("wpsg_rabatt_produktrabatt", $_REQUEST['wpsg_rabatt_produktrabatt']); update_option("wpsg_rabatt_produktgruppen", $_REQUEST['wpsg_rabatt_produktgruppen']); update_option("wpsg_rabatt_generell", $_REQUEST['wpsg_rabatt_generell']); update_option("wpsg_rabatt_generell_von", $_REQUEST['wpsg_rabatt_generell_von']); update_option("wpsg_rabatt_generell_bis", $_REQUEST['wpsg_rabatt_generell_bis']); update_option("wpsg_rabatt_generell_value", $_REQUEST['wpsg_rabatt_generell_value']); } private function getOptionData() { if (@is_array(get_option("wpsg_rabatt_data"))) $data_rabatt = get_option("wpsg_rabatt_data"); else { $data_rabatt = @unserialize(get_option("wpsg_rabatt_data")); if (!is_array($data_rabatt)) $data_rabatt = array(); } usort($data_rabatt, array($this, "cmp")); return $data_rabatt; } public function getRabatt($value) { $data_rabatt = $this->getOptionData(); $rabatt = 0; foreach ((array)$data_rabatt as $k => $v) { if ($value >= $v['value']) $rabatt = $v['rabatt']; } if (strpos($rabatt, "%") > 0) { return -1 * ($value / 100 * str_replace("%", "", $rabatt)); } else { return -1 * $rabatt; } return $rabatt; } public function settings_edit() { $data_rabatt = $this->getOptionData(); $content = '
				<tr>
					<td colspan="2">&nbsp;</td>
				</tr> 
				<tr>
					<th><label for="wpsg_rabatt_produktrabatt">'.__("Rabatt auf Produkte", "wpsg").'</label></th>
					<td>
						<input name="wpsg_rabatt_produktrabatt" id="wpsg_rabatt_produktrabatt" type="checkbox" value="1" '.((get_option("wpsg_rabatt_produktrabatt") == "1")?'checked="checked"':'').' />
					</td>
				</tr>
			'; if (array_key_exists("mod_produktgruppen", $this->controller->mods)) { $content .= '			
					<tr>
						<th><label for="wpsg_rabatt_produktgruppen">'.__("Rabatt auf Produktgruppen", "wpsg").'</label></th>
						<td>
							<input name="wpsg_rabatt_produktgruppen" id="wpsg_rabatt_produktgruppen" type="checkbox" value="1" '.((get_option("wpsg_rabatt_produktgruppen") == "1")?'checked="checked"':'').' />
						</td>
					</tr>
				'; } $content .= '
				<tr>
					<th><label for="wpsg_rabatt_generell">'.__("Genereller Rabatt", "wpsg").'</label></th>
					<td>
						<input name="wpsg_rabatt_generell" id="wpsg_rabatt_generell" type="checkbox" onclick="jQuery(\'#wpsg_rabatt_generell_table\').toggle();" value="1" '.((get_option("wpsg_rabatt_generell") == "1")?'checked="checked"':'').' />
					</td>
				</tr>
				<tr>
					<th></th>
					<td>
					
						<table id="wpsg_rabatt_generell_table" style="width:400px; '.((get_option("wpsg_rabatt_generell") == "1")?'':'display:none;').'" cellpadding="0" cellspacing="0">
							<tr>
								<th>'.__("Von (dd.mm.YYYY)", "wpsg").'</th>
								<th>'.__("Bis (dd.mm.YYYY)", "wpsg").'</th>
								<th>'.__("Rabatt (in %)", "wpsg").'</th>
							</tr>
							<tr>
								<td><input name="wpsg_rabatt_generell_von" type="text" value="'.get_option("wpsg_rabatt_generell_von").'" id="wpsg_rabatt_generell_von" /></td>
								<td><input name="wpsg_rabatt_generell_bis" type="text" value="'.get_option("wpsg_rabatt_generell_bis").'" id="wpsg_rabatt_generell_bis" /></td>
								<td><input name="wpsg_rabatt_generell_value" type="text" value="'.get_option("wpsg_rabatt_generell_value").'" id="wpsg_rabatt_generell_value" /></td>
							</tr>							
						</table> 
						
					</td>
				</tr>
				<tr><td colspan="2">&nbsp;</td></tr>
				<tr>
					<th><label style="font-weight:bold;">'.__("Staffelung", "wpsg").':</label></th> 
					<td></td>
				</tr> 
				<tr>
					<td colspan="2">
						<table style="width:500px;">
							<tr>
								<th style="width:150px;"><u>'.__("Bestellwert", "wpsg").'</u></th>
								<th><u>'.__("Rabatt", "wpsg").'</u></th>
								<th></th>
							</tr>
							<tr>
								<td>'.__("ab", "wpsg").' 0,00 '.get_option("wpshopgermany_currency").'</td>
								<td><input size="8" type="text" name="value[0][rabatt]" value="'.$this->f($data_rabatt[0]['rabatt']).'"/></td>
								<td></td>
							</tr>
			'; foreach ($data_rabatt as $k => $v) { if ($k > 0) { $content .= '
								<tr>
									<td>
										'.__("ab", "wpsg").' '.number_format($v['value'], 2, ',', '.').' '.get_option("wpshopgermany_currency").'
										<input type="hidden" name="value['.$k.'][value]" value="'.$this->f($v['value']).'" />
									</td>
									<td><input size="8" type="text" name="value['.$k.'][rabatt]" value="'.$this->f($v['rabatt']).'" /></td>
									<td>
										<label>
											<input type="checkbox" value="1" name="value['.$k.'][del]" />
											&nbsp;'.__("löschen", "wpsg").'
										</label>
									</td>
								</tr>
					'; } } $content .= '
							<tr>
								<td>'.__("ab", "wpsg").' <input type="text" size="8" name="neu[value]" value="'.$_REQUEST['neu']['value'].'"/> '.get_option("wpshopgermany_currency").'</td>
								<td><input size="8" type="text" name="neu[rabatt]" value="'.$_REQUEST['neu']['rabatt'].'"/> </td>
								<td></td>
							</tr>
			'; $content .= '
						</table>
					</td>
				</tr>
			'; return $content; } public function mod_produktgruppen_add() { if (get_option("wpsg_rabatt_produktgruppen") != "1") return; $this->controller->data['rabatt'] = explode("_", $this->controller->mods['mod_produktgruppen']->data['rabatt']); return $this->controller->loadTemplate(dirname(__FILE__)."/../views/mods/mod_rabatt/produktgruppen_addedit.phtml"); } public function mod_produktgruppen_save(&$data) { if (get_option("wpsg_rabatt_produktgruppen") != "1") return; $rabatt = ""; $rabatt_str = $_REQUEST['rabatt_aktiv']."_".$_REQUEST['rabatt_von']."_".$_REQUEST['rabatt_bis']."_".$_REQUEST['rabatt_value']; $data['rabatt'] = $rabatt_str; } public function Produkt_add() { if (get_option("wpsg_rabatt_produktrabatt") != "1") return; $this->controller->data['rabatt'] = explode("_", $this->controller->data['rabatt']); return $this->controller->loadTemplate(dirname(__FILE__)."/../views/mods/mod_rabatt/produkt_addedit.phtml"); } public function Produkt_save(&$data) { if (get_option("wpsg_rabatt_produktrabatt") != "1") return; $rabatt = ""; $rabatt_str = $_REQUEST['rabatt_aktiv']."_".$_REQUEST['rabatt_von']."_".$_REQUEST['rabatt_bis']."_".$_REQUEST['rabatt_value']; $data['rabatt'] = $rabatt_str; } private function cmp($a, $b) { if ($a['value'] == $b['value']) { return 0; } return ($a['value'] < $b['value']) ? -1 : 1; } public function Warenkorb_addForm(&$data) { if ($data['noRabatt']) return; $bRabatt_allgemein = true; if (get_option("wpsg_rabatt_generell") != "1") { $bRabatt_allgemein = false; } if (!preg_match("/\d{2}\.\d{2}\.\d{4}/", get_option("wpsg_rabatt_generell_von")) || !preg_match("/\d{2}\.\d{2}\.\d{4}/", get_option("wpsg_rabatt_generell_bis")) || !is_float((float)get_option("wpsg_rabatt_generell_value"))) { $bRabatt_allgemein = false; } if ($bRabatt_allgemein) { $rabatt_value = (float)get_option("wpsg_rabatt_generell_value"); $rabatt_start = strtotime(get_option("wpsg_rabatt_generell_von")); $rabatt_end = strtotime(get_option("wpsg_rabatt_generell_bis")); if ( time() >= $rabatt_start && time() <= $rabatt_end) { $rabatt_preis = $data['preis'] - ($data['preis'] / 100 * $rabatt_value); } } if (array_key_exists("mod_produktgruppen", $this->controller->mods)) { $bRabatt_produktgruppen = true; if (get_option("wpsg_rabatt_produktgruppen") != "1") { $bRabatt_produktgruppen = false; } else { $rabatt_produktgruppe = $this->controller->db->fetchOne("
						SELECT
							PG.`rabatt`
						FROM
							`".$this->controller->tbl_pr."` AS P
								LEFT JOIN `".$this->controller->tbl_pg."` AS PG ON (P.`pgruppe` = PG.`id`)
						WHERE
							P.`id` = '".wpsg_q($data['p_id'])."'								
					"); $rabatt = explode("_", $rabatt_produktgruppe); } if ($rabatt[0] != "1" || !preg_match("/\d{2}\.\d{2}\.\d{4}/", $rabatt[1]) || !preg_match("/\d{2}\.\d{2}\.\d{4}/", $rabatt[2]) || !is_float((float)$rabatt[3])) { $bRabatt_allgemein = false; } if ($bRabatt_allgemein) { $rabatt_value = (float)$rabatt[3]; $rabatt_start = strtotime($rabatt[1]); $rabatt_end = strtotime($rabatt[2]); if ( time() >= $rabatt_start && time() <= $rabatt_end) { $rabatt_preis = $data['preis'] - ($data['preis'] / 100 * $rabatt_value); } } } $bRabatt_produkt = true; if (get_option("wpsg_rabatt_produktrabatt") != "1") { $bRabatt_produkt = false; } else { $rabatt_produkt = $this->controller->db->fetchOne("
					SELECT
						P.`rabatt`
					FROM
						`".$this->controller->tbl_pr."` AS P
					WHERE
						`id` = '".wpsg_q($data['p_id'])."' 
				"); $rabatt = explode("_", $rabatt_produkt); } if ($rabatt[0] != "1" || !preg_match("/\d{2}\.\d{2}\.\d{4}/", $rabatt[1]) || !preg_match("/\d{2}\.\d{2}\.\d{4}/", $rabatt[2]) || !is_float((float)$rabatt[3])) { $bRabatt_produkt = false; } if ($bRabatt_produkt) { $rabatt_value = (float)$rabatt[3]; $rabatt_start = strtotime($rabatt[1]); $rabatt_end = strtotime($rabatt[2]); if ( time() >= $rabatt_start && time() <= $rabatt_end) { $rabatt_preis = $data['preis'] - ($data['preis'] / 100 * $rabatt_value); } } if ($rabatt_preis != "") { $data['preis_original'] = $data['preis']; $data['preis'] = $rabatt_preis; $GLOBALS['wpsg_special_preis'][$data['p_id']] = $data['preis']; $_SESSION['wpsg_special_preis'][$data['p_id']] = $data['preis']; } } public function clear($value) { if (strpos($value, ".") > 0) { if (strpos($value, ',') > 0) { return str_replace(",", ".", str_replace(".", "", $value)); } else { return $value; } } else { if (strpos($value, ",") > 0) { return str_replace(",", ".", $value); } else { return $value; } } } public function f($value) { $suffix = ""; if (strpos($value, "%") > 0) $suffix = "%"; return number_format((double)str_replace(",", ".", $value), 2, ',', '.').$suffix; } } ?>