<?php
 class mod_varianten extends mod_basic { var $name = "Varianten"; var $desc = 'Erlaubt die Definition von Produktvarianten.'; var $group = 'Produkte'; var $hilfeURL = 'http://wpshopgermany.maennchen1.de/2010/07/07/funktion-der-varianten-und-hinweise/'; var $id = 99; public function Produkt_add() { if ($_REQUEST['edit_id'] <= 0) return; if ($this->controller->data['typ'] == "produktpaket") { return; } return $this->controller->loadTemplate(dirname(__FILE__)."/../views/mods/mod_varianten/produkt_addedit.phtml"); } public function Warenkorb_addForm(&$data) { $arVari = $this->controller->db->fetchAssoc("SELECT * FROM `".$this->controller->tbl_vr."` WHERE `p_id` = '".wpsg_q($data['p_id'])."' AND `deleted` = '0' ", "id"); if ($this->controller->isOtherLang()) { foreach ($arVari as $k => $v) { $locale = @unserialize($v['locale']); if (is_array($locale) && $locale[get_locale()]['name'] != "") { $arVari[$k]['name'] = $locale[get_locale()]['name']; } } } $data['mod_varianten'] = $arVari; } public function install() { } public function Admin_template() { foreach ($this->controller->view['arTemplates'] as $t_id => $t) { if ($t_id == 1 || $t['ref'] == 1) { $this->controller->view['arTemplates'][$t_id]['platzhalter'][] = array("Varianten", "###mod_vari###"); } } $this->arPlatzhalter = array( array("ID der Variante", "###var_id###"), array("Name der Variante", "###var_name###"), array("Preis der Variante", "###var_preis###"), array("Preis der Variante + Produktpreis", "###var_preis_gesamt###"), array("Einheit des Gewichts", "###mod_weight_unit###") ); if (array_key_exists("mod_weight", $this->controller->mods)) $this->arPlatzhalter[] = array("Gewicht der Variante", "###var_weight###"); if (array_key_exists("mod_stock", $this->controller->mods)) $this->arPlatzhalter[] = array("Lagerbestand der Variante", "###var_stock###"); } public function Produkt_ajax() { if ($_REQUEST['edit_id'] < 0) die("Parameterfehler!"); if ($_REQUEST['command'] == "addVari") { $_REQUEST['preis'] = preg_replace("/,/", ".", $_REQUEST['preis']); $strError = ""; if ($_REQUEST['name'] == "") $strError = "Bitte einen Namen angeben!"; if ($strError != "") { echo '<ul class="error">'; echo '<li>'.$strError.'</li>'; echo '</ul>'; } else { $data = array( "p_id" => wpsg_q($_REQUEST['edit_id']), "preis" => wpsg_q($this->controller->getNumberValue($_REQUEST['preis'])), "name" => stripslashes($_REQUEST['name']) ); if (array_key_exists("mod_weight", $this->controller->mods)) $data['weight'] = wpsg_q(preg_replace("/\,/", ".", $_REQUEST['weight'])); if (array_key_exists("mod_stock", $this->controller->mods)) $data['stock'] = wpsg_q($_REQUEST['stock']); $this->controller->db->importQuery($this->controller->tbl_vr, $data); } die($this->renderListe()); } else if ($_REQUEST['command'] == "inlineEdit") { if ($_REQUEST['typ'] == "vari") { if (intval($_REQUEST['v_id']) <= 0) die(); if ($_REQUEST['col'] == "preis" || $_REQUEST['col'] == "weight") $_REQUEST['q'] = preg_replace("/,/", ".", $_REQUEST['q']); if ($_REQUEST['col'] == "name" && isset($_REQUEST['wpsg_lang'])) { $locale = @unserialize($this->controller->db->fetchOne("SELECT `locale` FROM `".$this->controller->tbl_vr."` WHERE `id` = '".wpsg_q($_REQUEST['v_id'])."' ")); if (!is_array($locale)) $locale = array(); $locale[$_REQUEST['wpsg_lang']]['name'] = $_REQUEST['q']; $this->controller->db->UpdateQuery($this->controller->tbl_vr, array("locale" => serialize($locale)), "`id` = '".wpsg_q($_REQUEST['v_id'])."'"); die($_REQUEST['q']); } $this->controller->db->UpdateQuery($this->controller->tbl_vr, array($_REQUEST['col'] => wpsg_q($_REQUEST['q'])), "`id` = '".wpsg_q($_REQUEST['v_id'])."'"); if ($_REQUEST['col'] == "preis" || $_REQUEST['col'] == "weight") die(number_format($_REQUEST['q'], 2, ',', '.')); die($_REQUEST['q']); } } else if ($_REQUEST['command'] == "delVari") { $this->controller->db->UpdateQuery($this->controller->tbl_vr, array( "deleted" => 1 ), "`id` = '".wpsg_q($_REQUEST['v_id'])."'"); die($this->renderListe()); } } public function Warenkorb_update() { if (intval($_REQUEST['vari']) > 0) { $bFound = false; foreach ((array)$_SESSION['wpshopgermany']['basket'][$_REQUEST['produkt']]['vari'] as $k => $v) { if ($k == $_REQUEST['vari']) { $_SESSION['wpshopgermany']['basket'][$_REQUEST['produkt']]['vari'][$k]['menge'] += intval($_REQUEST['menge']); $_SESSION['wpshopgermany']['basket'][$_REQUEST['produkt']]['vari'][$k]['referer'] = $_SERVER['HTTP_REFERER']; $bFound = true; $this->controller->do = "refresh"; } } if ($bFound == false) { if (!is_array($_SESSION['wpshopgermany']['basket'][$_REQUEST['produkt']]['vari'])) $_SESSION['wpshopgermany']['basket'][$_REQUEST['produkt']]['vari'] = array(); $_SESSION['wpshopgermany']['basket'][$_REQUEST['produkt']]['vari'][$_REQUEST['vari']] = array( "v_id" => intval($_REQUEST['vari']), "menge" => intval($_REQUEST['menge']), "referer" => $_SERVER['HTTP_REFERER'] ); $this->controller->do = "insert"; } $this->controller->updateDone = true; } } public function Warenkorb_add() { if (intval($_REQUEST['vari']) > 0) { $nVarianten = $this->controller->db->fetchOne("SELECT COUNT(*) FROM `".$this->controller->tbl_vr."` WHERE `p_id` = '".wpsg_q($_REQUEST['produkt'])."'"); $nProdVari = $this->controller->db->fetchOne("SELECT `p_id` FROM `".$this->controller->tbl_vr."` WHERE `id` = '".wpsg_q($_REQUEST['vari'])."' "); if ($nProdVari != $_REQUEST['produkt'] || $nVarianten <= 0) { $this->controller->addDone = true; return; } $_SESSION['wpshopgermany']['basket'][intval($_REQUEST['produkt'])] = array( "produkt_id" => intval($_REQUEST['produkt']) ); $_SESSION['wpshopgermany']['basket'][intval($_REQUEST['produkt'])]['vari'] = array(); $_SESSION['wpshopgermany']['basket'][intval($_REQUEST['produkt'])]['vari'][intval($_REQUEST['vari'])] = array( "v_id" => intval($_REQUEST['vari']), "menge" => intval($_REQUEST['menge']), "referer" => $_SERVER['HTTP_REFERER'] ); $this->controller->addDone = true; } } public function Warenkorb_countArtikel() { foreach ($this->controller->basket as $p) { foreach ((array)$p['vari'] as $v) { $this->controller->nCount += $v['menge']; } } } public function Warenkorb_calculateBasket(&$data) { if (!is_array($data['vari'])) return; foreach ($data['vari'] as $v) { $this->controller->sum += $v['menge'] * ($v['preis'] + $data['preis']); } $this->controller->calcDone = true; } public function Warenkorb_refreshBasket() { foreach ($this->controller->basket as $p_id => $p_data) { if (is_array($p_data['vari'])) { foreach ($p_data['vari'] as $v_id => $v_data) { $var = $this->controller->db->fetchRow("SELECT * FROM `".$this->controller->tbl_vr."` WHERE `id` = '".wpsg_q($v_id)."'"); if ($this->controller->isOtherLang()) { $locale = @unserialize($var['locale']); if (is_array($locale) && $locale[get_locale()]['name'] != "") { $var['name'] = $locale[get_locale()]['name']; } } $this->controller->basket[$p_id]['vari'][$v_id] = array_merge($v_data, array( "name" => $var['name'], "preis" => $var['preis'] )); } } } } public function Warenkorb_remove($p_id, $m) { $arID = explode("_", $_REQUEST['submit_removeprodukt']); if (sizeof($arID) != 2) return false; unset($_SESSION['wpshopgermany']['basket'][$arID[1]]['vari'][$arID[0]]); if (sizeof($_SESSION['wpshopgermany']['basket'][$arID[1]]['vari']) == 0) { unset($_SESSION['wpshopgermany']['basket'][$arID[1]]); } $this->controller->do = "remove"; $this->controller->removeDone == true; } public function Warenkorb_prepareBasketRendering() { $basket_neu = array(); if (is_array($this->controller->basket) && sizeof($this->controller->basket) > 0) { foreach ($this->controller->basket as $p_id => $p_data) { if (!is_array($p_data['vari'])) { $basket_neu[$p_id] = $p_data; } else { foreach ($p_data['vari'] as $v_id => $v_data) { $basket_neu[] = array( "produkt_id" => $p_id, "mwst" => $p_data['mwst'], "name" => $p_data['name'].' ['.$v_data['name'].']', "preis" => $p_data['preis'] + $v_data['preis'], "menge" => $v_data['menge'], "referer" => $v_data['referer'], "v_id" => $v_id ); } } } } if (is_array($basket_neu) && sizeof($basket_neu) > 0) $this->controller->basket = $basket_neu; } public function Warenkorb_refresh($p_id, $m) { if (preg_match("/\d*\_\d*/", $p_id)) { $ids = explode("_", $p_id); $p_id = $ids[1]; $v_id = $ids[0]; if ($m <= 0) { unset($_SESSION['wpshopgermany']['basket'][$p_id]['vari'][$v_id]); if (sizeof($_SESSION['wpshopgermany']['basket'][$p_id]['vari']) == 0) { unset($_SESSION['wpshopgermany']['basket'][$p_id]); } $this->controller->do = "remove"; } else { $_SESSION['wpshopgermany']['basket'][$p_id]['vari'][$v_id]['menge'] = $m; $this->controller->do = "refresh"; } $this->controller->refreshDone = true; } } public function Warenkorb_do2(&$data) { if ($data['v_id'] > 0) { $mwst = $this->controller->db->fetchOne("SELECT `value` FROM `".$this->controller->tbl_mw."` WHERE `id` = '".wpsg_q($data['mwst'])."'"); $this->controller->db->ImportQuery($this->controller->tbl_op, array( "o_id" => wpsg_q($this->controller->order_id), "p_id" => wpsg_q($data['produkt_id']), "v_id" => wpsg_q($data['v_id']), "menge" => wpsg_q($data['menge']), "price" => wpsg_q($data['preis']), "mwst" => wpsg_q($mwst) )); $this->controller->importDone = true; } } public function Order_view() { foreach ($this->controller->data['produkte'] as $k => $p) { if ($p['v_id'] > 0) { $vari = $this->controller->db->fetchRow("
						SELECT
							*
						FROM
							`".$this->controller->tbl_vr."`
						WHERE
							`id` = '".wpsg_q($p['v_id'])."'
					"); $this->controller->data['produkte'][$k]['name'] .= ' ['.$vari['name'].']'; } } } public function renderListe() { $arVari = $this->controller->db->fetchAssoc("SELECT * FROM `".$this->controller->tbl_vr."` WHERE `p_id` = '".wpsg_q($_REQUEST['edit_id'])."' AND `deleted` = '0'"); if (isset($_REQUEST['wpsg_lang'])) { foreach ($arVari as $k => $v) { $locale = @unserialize($v['locale']); if (is_array($locale) && $locale[$_REQUEST['wpsg_lang']]['name'] != "") { $arVari[$k]['name'] = $locale[$_REQUEST['wpsg_lang']]['name']; } } } if (sizeof($arVari) == 0) { $strContent .= '<p>'.__("Keine Varianten für dieses Produkt hinterlegt.", "wpsg").'</p>'; } else { $strContent .= '
					<table>
						<tr>
							<th style="text-align:left; width:150px;">'.__("Name", "wpsg").'</th>
							<th style="text-align:left; width:100px;">'.__("Preis in", "wpsg").' '.get_option("wpshopgermany_currency").'</th>
				'; if (array_key_exists("mod_weight", $this->controller->mods)) $strContent .= '<th style="width:100px;">'.__("Gewicht in", "wpsg").' '.get_option('wpshopgermany_weight_einheit').'</th>'; if (array_key_exists("mod_stock", $this->controller->mods)) $strContent .= '<th style="width:100px;">'.__("Lagerbestand", "wpsg").'</th>'; $strContent .= '
							<th>&nbsp;</th>
						</tr>
				'; $i = 0; foreach ($arVari as $v) { $strContent .= '
						<tr>
							<td id="variname_'.$v['id'].'">'.$v['name'].'</td>
							<td id="varivalue_'.$v['id'].'">'.number_format($v['preis'], 2, ',', '.').'</td>
					'; if (array_key_exists("mod_weight", $this->controller->mods)) $strContent .= '<td style="width:100px;" id="variweight_'.$v['id'].'">'.number_format($v['weight'], 2, ',', '.').'</td>'; if (array_key_exists("mod_stock", $this->controller->mods)) $strContent .= '<td style="width:100px;" class="varistock" id="varistock_'.$v['id'].'">'.$v['stock'].'</td>'; $strContent .= '<td style="height:22px;">'; if (!isset($_REQUEST['wpsg_lang'])) { $strContent .= '<input onclick="return delVari('.$v['id'].');" type="image" src="'.SITECOOKIEPATH.'wp-content/plugins/wpshopgermany/gfx/delete.png" title="'.__("Variante löschen", "wpsg").'" alt="'.__("Löschen", "wpsg").'" />'; } $strContent .= '
								<script type="text/javascript">
				
								    jQuery("#variname_'.$v['id'].'").editable("'.SITECOOKIEPATH.'wp-admin/admin.php?page=wpshopgermany-Produkt&action=ajax&noheader=1&command=inlineEdit", {
								    	extraParams: {  
								    		typ: "vari",
								    		v_id: '.$v['id'].',
					'; if (isset($_REQUEST['wpsg_lang'])) { $strContent .= 'wpsg_lang: "'.$_REQUEST['wpsg_lang'].'", '; } $strContent .= '
								    		col: "name"
										},
								        indicator: "'.__("Speicher...", "wpsg").'",
								    	tooltip: "'.__("Zum Bearbeiten anklicken...", "wpsg").'"
									});
									
									jQuery("#varivalue_'.$v['id'].'").editable("'.SITECOOKIEPATH.'wp-admin/admin.php?page=wpshopgermany-Produkt&action=ajax&noheader=1&command=inlineEdit", {
								    	extraParams: {  
								    		typ: "vari",
								    		v_id: '.$v['id'].',
								    		col: "preis"
										},
								        indicator: "'.__("Speicher...", "wpsg").'",
								    	tooltip: "'.__("Zum Bearbeiten anklicken...", "wpsg").'"
									});
									
					'; if (array_key_exists("mod_weight", $this->controller->mods)) $strContent .= '
									jQuery("#variweight_'.$v['id'].'").editable("'.SITECOOKIEPATH.'wp-admin/admin.php?page=wpshopgermany-Produkt&action=ajax&noheader=1&command=inlineEdit", {
								    	extraParams: {  
								    		typ: "vari",
								    		v_id: '.$v['id'].',
								    		col: "weight"
										},
								        indicator: "'.__("Speicher...", "wpsg").'",
								    	tooltip: "'.__("Zum Bearbeiten anklicken...", "wpsg").'"
									});
					'; if (array_key_exists("mod_stock", $this->controller->mods)) $strContent .= '
									jQuery("#varistock_'.$v['id'].'").editable("'.SITECOOKIEPATH.'wp-admin/admin.php?page=wpshopgermany-Produkt&action=ajax&noheader=1&command=inlineEdit", {
										extraParams: {
											typ: "vari",
											v_id: '.$v['id'].',
											col: "stock"
										},
										callback: function() {
											setStockVari();
										},
										indicator: "'.__("Speicher...", "wpsg").'",
								    	tooltip: "'.__("Zum Bearbeiten anklicken...", "wpsg").'"
									});
									
									setStockVari();
									
					'; $strContent .= '
																							
								</script>
								
							</td>
						</tr>
					'; } $strContent .= '
					</table>
				'; } return $strContent; } } ?>