<?php
 class Basket { var $db; var $controller; var $arProdukte; public function __construct($controller) { $this->db = $controller->db; $this->controller = $controller; $this->arProdukte = array(); } public function initFromSession() { foreach ($_SESSION['wpshopgermany']['basket'] as $p_id => $p_data) { $produkt = array("p_id" => $p_id); $this->loadDBContent($produkt); if ($p_data['special_preis'] > 0) $produkt['preis'] = $p_data['special_preis']; $produkt['menge'] = $p_data['menge']; $produkt['referer'] = $p_data['referer']; Basket::loadBilder($produkt); $this->arProdukte[$p_id] = $produkt; } } public function getProduktanzahl() { return sizeof($this->arProdukte); } public function getProdukte() { return $this->arProdukte; } public function getNetto() { $netto = 0; foreach ($this->arProdukte as $p) { $gp = $p['preis'] * $p['menge']; $netto += $gp / (1 + ($p['mwst_value'] / 100)); } return $netto; } public function getBrutto() { $brutto = 0; foreach ($this->arProdukte as $p) { $brutto += $p['preis'] * $p['menge']; } return $brutto; } public function getTipForBasket() { $arPIDs = array(); foreach ($this->arProdukte as $p) { $arPIDs[] = $p['p_id']; } $produkt_db = $this->db->fetchRow("
				SELECT
					P.*,
					(SELECT `value` FROM `".$this->controller->tbl_mw."` WHERE `id` = P.`mwst`) AS mwst_value
				FROM 
					`".$this->controller->tbl_pr."` AS P
				WHERE 
					P.`id` NOT IN (".implode(",", $arPIDs).") AND 
					P.`deleted` != '1' 
				ORDER BY 
					RAND() 
				LIMIT 1
			"); $produkt = false; if (is_array($produkt_db) && sizeof($produkt_db) > 0) { $produkt = array("p_id" => $produkt_db['id']); $this->loadDBContent($produkt); $produkt['menge'] = 0; Basket::loadBilder($produkt); } return $produkt; } public function loadProdukt($p_id) { $produkt = array("p_id" => $p_id); $this->loadDBContent($produkt); Basket::loadBilder($produkt); return $produkt; } private function loadDBContent(&$produkt) { $produkt_db = $this->db->fetchRow("
				SELECT
					P.*,
					(SELECT `value` FROM `".$this->controller->tbl_mw."` WHERE `id` = P.`mwst`) AS mwst_value
				FROM 
					`".$this->controller->tbl_pr."` AS P
				WHERE 
					P.`id` = '".wpsg_q($produkt['p_id'])."'
			"); $produkt = array( "p_id" => $produkt_db['id'], "partikel" => $produkt_db['partikel'], "beschreibung" => $produkt_db['beschreibung'], "menge" => 0, "referer" => '', "preis" => $produkt_db['preis'], "name" => $produkt_db['name'], "typ" => $produkt_db['typ'], "mwst_value" => $produkt_db['mwst_value'] ); $produkt['attribute'] = array(); $att = $this->db->fetchAssoc("SELECT * FROM `".$this->controller->tbl_pa."` WHERE `p_id` = '".wpsg_q($produkt['p_id'])."' "); foreach ($att as $a) { $produkt['attribute'][$a['a_id']] = $a['value']; } if (array_key_exists("mod_rabatt", $this->controller->mods)) { $this->controller->mods["mod_rabatt"]->Warenkorb_addForm($produkt); } } public function getRelatedProducts($produkt_id, $nCount = 10) { $arProdukts = $this->db->fetchAssoc("
				SELECT
					P.*,
					P.`id` AS p_id,
					(
						SELECT 
							COUNT(*)
						FROM 
							(
								SELECT 
									GROUP_CONCAT(p_id) AS rel 
								FROM 
									`".$this->controller->tbl_op."` AS OP
								GROUP BY o_id
							) AS relevanteprodukte
						WHERE 
							FIND_IN_SET('".wpsg_q($produkt_id)."', rel)
					) AS ordered_together					
				FROM
					`".$this->controller->tbl_pr."` AS P
				ORDER BY 
					`ordered_together` DESC
			"); return $arProdukts; } public static function loadBilder(&$produkt) { $produkt['bilder'] = array(); $handle = opendir(WP_CONTENT_DIR.'/uploads/produktbilder/'.$produkt['p_id']."/"); while($filename = readdir($handle)) { $file = WP_CONTENT_DIR.'/uploads/produktbilder/'.$produkt['p_id']."/".$filename; if (is_file($file) && $file != "." && $file != "..") { $produkt['bilder'][] = $filename; } } closedir($handle); asort($produkt['bilder']); $arReturn = array(); foreach ($produkt['bilder'] as $b) { $arReturn[] = $b; } $produkt['bilder'] = $arReturn; } } ?>