<?php
 class mod_paypal extends mod_basic { var $id = 2; var $name = "Paypal"; var $desc = 'Dieses Modul erlaubt die Zahlungsart "Paypal". Bestellungen dieses Typs erhalten den Status "warte auf Paypal Zahlung". Wird die Zahlung über Paypal erfolgreich abgewickelt, so ändert sich der Status der Bestellung entsprechend.'; var $group = 'Zahlungsmethoden'; var $lizenz = 1; public function settings_edit() { $this->controller->opt_val['wpshopgermany_paypal_mail'] = get_option('wpshopgermany_paypal_mail'); $this->controller->opt_val['wpshopgermany_paypal_sandbox'] = get_option('wpshopgermany_paypal_sandbox'); $this->controller->opt_val['wpshopgermany_paypal_rabgb'] = get_option('wpshopgermany_paypal_rabgb'); $content = '
				<tr>
					<th><label>'.__("PayPal E-Mail:", "wpsg").'</label></th> 
					<td><input type="text" class="regular-text" name="wpshopgermany_paypal_mail" value="'.$this->controller->opt_val['wpshopgermany_paypal_mail'].'" size="20"/></td>
				</tr>
				<tr>
					<th><label>'.__("Gebühr/Rabatt", "wpsg").'</label></th>
					<td>
						<input type="text" class="regular-text" name="wpshopgermany_paypal_rabgb" value="'.$this->controller->opt_val['wpshopgermany_paypal_rabgb'].'" size="20"/>
						<a target="_new" title="'.__("Weitere Informationen zum Theme Rabatte/Gebühren für Zahlungsmethoden", "wpsg").'" href="http://wpshopgermany.maennchen1.de/?p=603"><img src="/wp-content/plugins/wpshopgermany/gfx/help.png" alt="Hilfe"/></a>
					</td>					
				</tr>
				<tr>
					<th><label>'.__("Zahlung sofort starten", "wpsg").':</label></th>
					<td><input type="checkbox" name="wpshopgermany_paypal_go" value="1" '.((get_option('wpshopgermany_paypal_go') == "1")?'checked="checked"':'').' /></td>
				</tr>
				<tr>
					<th><label>Sandboxmodus</label></th>
					<td><input type="checkbox" name="wpshopgermany_paypal_sandbox" value="1" '.(($this->controller->opt_val['wpshopgermany_paypal_sandbox'] == 1)?'checked="checked"':'').'/></td>
				</tr>
				<tr>
					<th>'.__("Erfolgslink", "wpsg").':</th>
					<td>
					
						<script type="text/javascript">
						
							var url = new Object();
						
				'; foreach (get_pages() as $page) { $arUrl[$page->ID] = get_permalink($page->ID); $content .= 'url["'.$page->ID.'"] = "'.get_permalink($page->ID).'";'; } $content .= '
						</script>
					
						<select name="wpshopgermany_pp_pageconfirm" onchange="if (this.value != \'\') { jQuery(\'#wpshopgermany_pp_pageconfirm_url\').val(url[this.value]); } else { jQuery(\'#wpshopgermany_pp_pageconfirm_url\').val(\'\'); } ">
							<option value="">'.__("Seite auswählen", "wpsg").'</option>
			'; foreach (get_pages() as $page) { $content .= '<option value="'.$page->ID.'" '.((get_option('wpshopgermany_pp_pageconfirm') == $page->ID)?'selected="selected"':'').'>'.$page->post_title.'</option>'; } $content .= '
						</select>
						<br />
						<div style="display:inline;"><input id="wpshopgermany_pp_pageconfirm_url" name="wpshopgermany_pp_pageconfirm_url" size="20" class="regular-text" type="text" value="'.get_option("wpshopgermany_pp_pageconfirm_url").'" name="" /></div>
					</td>
				</tr>
				<tr>
					<th>'.__("Abbruchlink", "wpsg").':</th>
					<td>					
						<select name="wpshopgermany_pp_pageerror" onchange="if (this.value != \'\') { jQuery(\'#wpshopgermany_pp_pageerror_url\').val(url[this.value]); } else { jQuery(\'#wpshopgermany_pp_pageerror_url\').val(\'\'); } ">
							<option value="">'.__("Seite auswählen", "wpsg").'</option>
			'; foreach (get_pages() as $page) { $content .= '<option value="'.$page->ID.'" '.((get_option('wpshopgermany_pp_pageerror') == $page->ID)?'selected="selected"':'').'>'.$page->post_title.'</option>'; } $content .= '
						</select>
						<br />
						<div style="display:inline;"><input id="wpshopgermany_pp_pageerror_url" name="wpshopgermany_pp_pageerror_url" class="regular-text" size="20" type="text" value="'.get_option("wpshopgermany_pp_pageerror_url").'" /></div>
					</td>
				</tr>	
				<tr>
					<td colspan="2">
						<br />
						<i>
							Zur Anbindung an den PayPal Service wird <a href="https://www.paypalobjects.com/de_DE/html/IntegrationCenter/ic_pps_home.html" target="_blank">PayPal Starter</a> genutzt. Fortführende Details finden Sie im <a href="https://www.paypalobjects.com/de_DE/pdf/PayPal-Starter-Integrationshandbuch.pdf" target="_blank">Paypal Starter Integrationshandbuch</a>.<br />
							Im Integrationshandbuch erfahren Sie auch, wie Sie die <strong>Sandbox nutzen</strong>, um den Zahlungsverkehr zu testen.						
						</i>						
					</td>
				</tr>
			'; return $content; } public function settings_save() { update_option("wpshopgermany_paypal_mail", $_REQUEST['wpshopgermany_paypal_mail']); update_option("wpshopgermany_paypal_sandbox", $_REQUEST['wpshopgermany_paypal_sandbox']); update_option("wpshopgermany_paypal_rabgb", $_REQUEST['wpshopgermany_paypal_rabgb']); update_option("wpshopgermany_paypal_go", $_REQUEST['wpshopgermany_paypal_go']); update_option("wpshopgermany_pp_pageconfirm", $_REQUEST['wpshopgermany_pp_pageconfirm']); update_option("wpshopgermany_pp_pageerror", $_REQUEST['wpshopgermany_pp_pageerror']); update_option("wpshopgermany_pp_pageerror_url", $_REQUEST['wpshopgermany_pp_pageerror_url']); update_option("wpshopgermany_pp_pageconfirm_url", $_REQUEST['wpshopgermany_pp_pageconfirm_url']); } public function addPayment(&$arPayment, &$basket) { $arPayment[$this->id] = array( "id" => $this->id, "text_clear" => __("Paypal", "wpsg"), "text" => __("Paypal", "wpsg"), "rabgeb" => preg_replace("/,/", ".", get_option('wpshopgermany_paypal_rabgb')) ); $rabgb = preg_replace("/,/", ".", get_option('wpshopgermany_paypal_rabgb')); $this->addRabGeb($arPayment, $rabgb, $basket); } public function pluginFEAction() { if ($_REQUEST['confirm'] == "pp") { $emailtext = ""; if(function_exists('get_magic_quotes_gpc')) { $get_magic_quotes_exits = true; } $req = 'cmd=_notify-validate'; foreach ($_POST as $key => $value) { if($get_magic_quotes_exists == true && get_magic_quotes_gpc() == 1) { $value = urlencode(stripslashes($value)); } else { $value = urlencode($value); } $req .= "&$key=$value"; } $header = ""; $header .= "POST /cgi-bin/webscr HTTP/1.0\r\n"; $header .= "Content-Type: application/x-www-form-urlencoded\r\n"; $header .= "Content-Length: " . strlen($req) . "\r\n\r\n"; if (get_option('wpshopgermany_paypal_sandbox') == 1) $fp = fsockopen ('www.sandbox.paypal.com', 80, $errno, $errstr, 30); else $fp = fsockopen ('www.paypal.com', 80, $errno, $errstr, 30); if (!$fp) { $emailtext = "HTTP Error\r\n"; } else { fputs ($fp, $header.$req); while (!feof($fp)) { $res = fgets ($fp, 1024); if (strcmp($res, "VERIFIED") == 0) { global $wp_rewrite; $wp_rewrite = new WP_Rewrite(); $_REQUEST['edit_id'] = $_REQUEST['custom']; $_REQUEST['status'] = 100; $_REQUEST['send_mail'] = 1; $this->controller->db->updateQuery($this->controller->tbl_or, array("transaction" => $_REQUEST['txn_id']), "`id` = '".wpsg_q($_REQUEST['custom'])."'"); require_once(WP_PLUGIN_DIR."/wpshopgermany/controllers/OrderController.class.php"); $OC = new OrderController("Order", "setStatus", false, $this->controller->lizenz); $OC->init(); $OC->setStatusAction(false); $emailtext = "PayPal Zahlung erfolgt"; } else if (strcmp ($res, "INVALID") == 0) { $emailtext = "PayPal Zahlung fehlgeschlagen"; } } } } } public function getPayPalLink($order_id) { $basket_link = get_permalink(get_option('wpshopgermany_basketpage')); if (strpos($basket_link, "?") > 0) { $basket_link .= "&plugin=1&confirm=pp"; } else { $basket_link .= "?plugin=1&confirm=pp"; } $order = $this->controller->db->fetchRow("SELECT * FROM `".$this->controller->tbl_or."` WHERE `id` = '".wpsg_q($order_id)."'"); $op = $this->controller->db->fetchAssoc("
				SELECT 
					*,
					P.id AS produkt_id,
					price AS preis
				FROM 
					`".$this->controller->tbl_op."` AS OP 
						LEFT JOIN `".$this->controller->tbl_pr."` AS P ON (OP.p_id = P.id)
				WHERE
					OP.`o_id` = '".wpsg_q($order_id)."'
			", "id"); $gs_db = $this->controller->db->fetchRow("SELECT * FROM `".$this->controller->tbl_gs."` WHERE `o_id` = '".wpsg_q($order_id)."' "); if ($gs_db['id'] > 0) { $gs_db['produkt_id'] = "gs"; $gs_db['gs_id'] = $gs_db['id']; $gs_db['menge'] = 1; $gs_db['preis'] = $gs_db['value']; $op['gs'] = $gs_db; } if (get_class($this->controller) == "WarenkorbController") { $this->controller->basketController = $this->controller; } $this->controller->basketController->basket = $op; $this->controller->basketController->calculateBasket(); $items = ""; $i = 1; foreach ($this->controller->basketController->basket as $p) { if ($p['produkt_id'] == "gs") { $items .= '&discount_amount_cart='.rawurlencode($p['gs_value'] * -1).'&'; } else { $items .= '&item_name_'.$i.'='.rawurlencode($p['name']).'&'. 'amount_'.$i.'='.rawurlencode(round($p['preis'], 2)).'&'. 'quantity_'.$i.'='.rawurlencode($p['menge']).'&'. 'item_number_'.$i.'='.rawurlencode($p['p_id']).'&'. 'on0'.$i.'=Variante&'. 'os0'.$i.'='.$p['v_id']; $i ++; } } if (get_option('wpshopgermany_paypal_sandbox') == 1) $url = "https://www.sandbox.paypal.com/cgi-bin/webscr"; else $url = "https://www.paypal.com/cgi-bin/webscr"; $strLink = $url.'?cmd=_cart&upload=1&'. 'business='.rawurlencode(get_option('wpshopgermany_paypal_mail')).$items.'&'. 'shipping_1='.rawurlencode(round($order['price_shipping'], 2)).'&'. 'return='.rawurlencode(get_option("wpshopgermany_pp_pageconfirm_url")).'&'. 'cancel_return='.rawurlencode(get_option("wpshopgermany_pp_pageerror_url")).'&'. 'notify_url='.rawurlencode($basket_link).'&'. 'currency_code='.rawurlencode(get_option('wpshopgermany_currency')).'&'. 'lc=DE&'. 'custom='.rawurlencode($order_id); return $strLink; } public function Warenkorb_ordered($order_id) { if ($this->controller->order_data['type_payment'] == $this->id) { $this->basket_link = get_permalink(get_option('wpshopgermany_basketpage')); if (strpos($this->basket_link, "?") > 0) { $this->basket_link .= "&plugin=1&confirm=pp"; } else { $this->basket_link .= "?plugin=1&confirm=pp"; } if (get_option('wpshopgermany_paypal_sandbox') == 1) $this->paypal_url = "https://www.sandbox.paypal.com/cgi-bin/webscr"; else $this->paypal_url = "https://www.paypal.com/cgi-bin/webscr"; $this->paypal_amount = round($this->controller->order_data['price_gesamt'], 2); $this->paypal_item_name .= "K".$this->controller->order_data['k_id']." O".$order_id; if (get_option("wpshopgermany_paypal_go") == "1") { $url = $this->getPayPalLink($order_id); $url = str_replace("&", '" + String.fromCharCode(38) + "', $url); $this->controller->modText[50] = '<p>'.__("Vielen Dank für ihre Bestellung, sie werden umgehend zu Paypal weitergeleitet. Sollte dies nicht automatisch geschehen, so können sie auch ", "wpsg").'<a href="'.$url.'">'.__("hier", "wpsg").'</a> '.__("klicken.", "wpsg").'</p>'; $this->controller->modText[50] = '<script type="text/javascript"> location.href = "'.$url.'"; </script>'; } else { $this->controller->modText[50] = $this->renderOut("mod_paypal/formular.phtml"); } } } public function Order_getStatus() { $this->controller->arStatus[2] = "warte auf Paypal Zahlung"; } } ?>