<?php
 class mod_produktgruppen extends mod_basic { var $id = "9"; var $desc = "Erlaubt es für Produkte verschiedene Gruppen zu definieren und diese gebündelt anzuzeigen."; var $group = 'Produkte'; var $name = "Produktgruppen"; var $lizenz = 1; public function settings_edit() { if (get_option("mod_produktgruppen") != "1") return; return $this->controller->loadTemplate(dirname(__FILE__)."/../views/mods/mod_produktgruppen/settings_edit.phtml"); } public function settings_save() { if (get_option("mod_produktgruppen") != "1") return; update_option("wpshopgermany_produktgruppen_page", $_REQUEST['wpshopgermany_produktgruppen_page']); update_option("wpsg_produktgruppen_sort", $_REQUEST['wpsg_produktgruppen_sort']); } public function BE_index() { if ($_REQUEST['mod_action'] == "add") { $this->addAction(); } else if ($_REQUEST['mod_action'] == "edit") { $this->editAction(); } else if ($_REQUEST['mod_action'] == "del") { $this->delAction(); } else if ($_REQUEST['mod_action'] == "save") { $this->saveAction(); } else { $this->indexAction(); } return true; } public function editAction() { $this->data = $this->controller->db->fetchRow("SELECT * FROM `".$this->controller->tbl_pg."` WHERE `id` = '".wpsg_q($_REQUEST['edit_id'])."'"); $this->edit_id = $_REQUEST['edit_id']; $this->addAction(); } public function saveAction() { $data = array( "name" => stripslashes($_REQUEST['name']), "template_file" => $_REQUEST['template'], "infopage" => $_REQUEST['infopage'] ); foreach ($this->controller->mods as $m) { if (method_exists($m, "mod_produktgruppen_save")) { $m->mod_produktgruppen_save($data); } } if ($_REQUEST['edit_id'] > 0) { $this->controller->db->UpdateQuery($this->controller->tbl_pg, $data, "`id` = '".wpsg_q($_REQUEST['edit_id'])."' "); $new_id = $_REQUEST['edit_id']; } else { $data['cdate'] = "NOW()"; $new_id = $this->controller->db->ImportQuery($this->controller->tbl_pg, $data); } if (isset($_REQUEST['form_submit_index'])) { $this->indexAction(); } else { $_REQUEST['edit_id'] = $new_id; $this->editAction(); } } public function delAction() { $this->controller->db->Query("DELETE FROM `".$this->controller->tbl_pg."` WHERE `id` = '".wpsg_q($_REQUEST['edit_id'])."'"); $this->indexAction(); } public function addAction() { $arTemplates = $this->controller->loadProduktTemplates(); include $this->render("/mod_produktgruppen/add.phtml"); } public function indexAction() { $this->arGruppen = $this->controller->db->fetchAssoc("
				SELECT
					PG.*, 
					(SELECT COUNT(*) FROM `".$this->controller->tbl_pr."` WHERE `pgruppe` = PG.`id` AND `deleted` = '0') AS countProdukte
				FROM
					`".$this->controller->tbl_pg."` AS PG 					
			"); include $this->render("/mod_produktgruppen/index.phtml"); } public function Produkt_add_allgemein() { $this->controller->data['arPG'] = $this->controller->db->fetchAssoc("
				SELECT
					*
				FROM
					`".$this->controller->tbl_pg."`
			"); $sticky = $this->controller->db->fetchRow("SELECT * FROM `".$this->controller->tbl_ps."` WHERE `produkt_id` = '".wpsg_q($_REQUEST['edit_id'])."'"); $this->controller->data['mod_produktgruppen']['sticky'] = $sticky; return $this->controller->loadTemplate(dirname(__FILE__)."/../views/mods/mod_produktgruppen/produkt_addedit.phtml"); } public function addPages() { add_submenu_page('wpshopgermany-Admin-hide', __('Produktgruppen', 'wpsg'), __('Produktgruppen', 'wpsg'), 'administrator', 'wpshopgermany-mod_produktgruppen', 'dispatch'); } public function init() { global $wpdb; $this->controller->tbl_ps = $wpdb->prefix."wpshopgermany_produktsticky"; } public function install() { require_once(ABSPATH.'wp-admin/includes/upgrade.php'); $sql = "CREATE TABLE ".$this->controller->tbl_ps." (
		   		id mediumint(9) NOT NULL AUTO_INCREMENT,
		   		produkt_id INT(11) NOT NULL,
		   		von INT NOT NULL,
		   		bis INT NOT NULL,
		   		UNIQUE KEY id (id)
		   	);"; dbDelta($sql); } public function Produkt_save(&$data) { $data['pgruppe'] = $_REQUEST['pgruppe']; if (!isset($_REQUEST['edit_id'])) return; $data_ps = array(); if ($_REQUEST['wpsg_pg_sticky_start'] != "" && !preg_match("/\d{2}\.\d{2}\.\d{4}/", $_REQUEST['wpsg_pg_sticky_start'])) { $_SESSION['wpsg_admin_produkt_error'][] = __("Das Startdatum bei \"Sticky innerhalb der Produktgruppe\" war ungültig.", "wpsg"); } else if (preg_match("/\d{2}\.\d{2}\.\d{4}/", $_REQUEST['wpsg_pg_sticky_start'])) { $data_ps['von'] = strtotime($_REQUEST['wpsg_pg_sticky_start']); } else if (trim($_REQUEST['wpsg_pg_sticky_start']) == "") { $data_ps['von'] = ""; } if ($_REQUEST['wpsg_pg_sticky_end'] != "" && !preg_match("/\d{2}\.\d{2}\.\d{4}/", $_REQUEST['wpsg_pg_sticky_end'])) { $_SESSION['wpsg_admin_produkt_error'][] = __("Das Enddatum bei \"Sticky innerhalb der Produtkgruppe\" war ungültig.", "wpsg"); } else if (preg_match("/\d{2}\.\d{2}\.\d{4}/", $_REQUEST['wpsg_pg_sticky_end'])) { $data_ps['bis'] = strtotime($_REQUEST['wpsg_pg_sticky_end']); } else if (trim($_REQUEST['wpsg_pg_sticky_end']) == "") { $data_ps['bis'] = ""; } if (sizeof($data_ps) > 0) { $bExists = $this->controller->db->fetchOne("SELECT `id` FROM `".$this->controller->tbl_ps."` WHERE `produkt_id` = '".wpsg_q($_REQUEST['edit_id'])."'"); if ($bExists > 0) { $this->controller->db->UpdateQuery($this->controller->tbl_ps, $data_ps, "`id` = '".wpsg_q($bExists)."'"); } else { $data_ps['produkt_id'] = wpsg_q($_REQUEST['edit_id']); $this->controller->db->ImportQuery($this->controller->tbl_ps, $data_ps); } } return; } public function content_filter() { if (get_option('wpshopgermany_produktgruppen_page') != get_the_ID()) return ""; $strReturn = ""; if ($_REQUEST['show'] > 0) { $Gruppe = $this->controller->db->fetchRow("SELECT * FROM `".$this->controller->tbl_pg."` WHERE `id` = '".wpsg_q($_REQUEST['show'])."' AND `deleted` = '0' "); $strOrder = "sticky DESC"; if (get_option("wpsg_produktgruppen_sort") != "") { switch (get_option("wpsg_produktgruppen_sort")) { case 'id': $strOrder .= ", P.`id` ASC "; break; case 'alphabetisch': $strOrder .= ", P.`name` ASC "; break; case 'buyed': $strOrder .= ", `buyed` DESC "; break; case 'erstellungsdatum': $strOrder .= ", `cdate` DESC "; break; case 'preis': $strOrder .= ", `preis` DESC "; break; } } if ($strOrder != "") $strOrder = " ORDER BY ".$strOrder; $arProdukte = $this->controller->db->fetchAssoc("
					SELECT 
						P.*,
						(IF('".time()."' > PS.`von` AND '".time()."' < PS.`bis`, 1, 0)) AS sticky, 
						(SELECT SUM(`menge`) FROM `".$this->controller->tbl_op."` AS OP WHERE OP.`p_id` = P.`id`) AS buyed 
					FROM 
						`".$this->controller->tbl_pr."` AS P
							LEFT JOIN `".$this->controller->tbl_ps."` AS PS ON (P.`id` = PS.`produkt_id`)
					WHERE 
						P.`pgruppe` = '".wpsg_q($Gruppe['id'])."' AND 
						P.`deleted` = '0' 
					".$strOrder."
				"); foreach ($arProdukte as $k2 => $p) { $arFiles = array(); $dir = WP_CONTENT_DIR.'/uploads/produktbilder/'.$p['id']."/"; $handle = opendir($dir); while($filename = readdir($handle)) { $file = $dir.$filename; if (is_file($file) && $filename != "." && $filename != "..") { $arFiles[] = $filename; } } $arProdukte[$k2]['bilder'] = $arFiles; } $Gruppe['produkte'] = $arProdukte; ob_start(); include $this->render("mod_produktgruppen/show.phtml"); $strReturn = ob_get_contents(); ob_end_clean(); } else { $arGruppen = $this->controller->db->fetchAssoc("SELECT * FROM `".$this->controller->tbl_pg."` WHERE `deleted` = '0'  "); foreach ($arGruppen as $k => $pg) { $strOrder = "sticky DESC"; if (get_option("wpsg_produktgruppen_sort") != "") { switch (get_option("wpsg_produktgruppen_sort")) { case 'id': $strOrder .= ", P.`id` ASC "; break; case 'alphabetisch': $strOrder .= ", P.`name` ASC "; break; case 'buyed': $strOrder .= ", `buyed` DESC "; break; case 'erstellungsdatum': $strOrder .= ", `cdate` DESC "; break; case 'preis': $strOrder .= ", `preis` DESC "; break; } } if ($strOrder != "") $strOrder = " ORDER BY ".$strOrder; $arProdukte = array(); $arProdukte = $this->controller->db->fetchAssoc("
						SELECT 
							P.*, 
							(IF('".time()."' > PS.`von` AND '".time()."' < PS.`bis`, 1, 0)) AS sticky, 
							(SELECT SUM(`menge`) FROM `".$this->controller->tbl_op."` AS OP WHERE OP.`p_id` = P.`id`) AS buyed 
						FROM 
							`".$this->controller->tbl_pr."` AS P		
								LEFT JOIN `".$this->controller->tbl_ps."` AS PS ON (P.`id` = PS.`produkt_id`)					
						WHERE 
							P.`pgruppe` = '".wpsg_q($pg['id'])."' AND 
							P.`deleted` = '0' 
						".$strOrder."
					"); foreach ($arProdukte as $k2 => $p) { $arFiles = array(); $dir = WP_CONTENT_DIR.'/uploads/produktbilder/'.$p['id']."/"; $handle = opendir($dir); while($filename = readdir($handle)) { $file = $dir.$filename; if (is_file($file) && $filename != "." && $filename != "..") { $arFiles[] = $filename; } } $arProdukte[$k2]['bilder'] = $arFiles; } $arGruppen[$k]['produkte'] = $arProdukte; } ob_start(); include $this->render("mod_produktgruppen/list.phtml"); $strReturn = ob_get_contents(); ob_end_clean(); } return $strReturn; } } ?>