<?php
 class mod_userpayment extends mod_basic { var $id = 96; var $name = "Zahlvarianten"; var $desc = 'Erlaubt das anlegen von benutzerdefinierten Zahlungsarten.'; var $group = 'Zahlungsmethoden'; var $lizenz = 1; public function __construct($controller) { global $wpdb; parent::__construct($controller); $this->controller->tbl_zv = $wpdb->prefix."wpshopgermany_zahlvarianten"; } public function settings_edit() { if (get_option("mod_userpayment") != "1") return; $arZV = $this->controller->db->fetchAssoc("SELECT * FROM `".$this->controller->tbl_zv."` "); $content = '
				<tr><td colspan="2">
					<table border="0" cellpadding="0" cellspacing="0">
						<tr><td colspan="2">&nbsp;</td></tr>
						<tr>
							<th></th>
							<th>'.__("Bezeichnung", "wpsg").'</th>
							<th>'.__("Rabatt/Gebühr", "wpsg").'</th>
							<th></th>
						</tr>
			'; foreach ($arZV as $zv) { $content .= '
						<tr>
							<th></th>
							<td>
								<input type="text" name="zv['.$zv['id'].'][name]" value="'.$zv['name'].'" />
							</td>
							<td>
								<input type="text" name="zv['.$zv['id'].'][rabgeb]" value="'.$zv['rabgeb'].'" />
							</td>
							<td>
								<label>
									<input type="checkbox" value="1" name="del['.$zv['id'].']" />&nbsp;'.__("Löschen", "wpsg").'
								</label>
							</td>
						</tr>
				'; } $content .= '
						<tr><td colspan="2">&nbsp;</td></tr>
						<tr>
							<th>'.__("Neu", "wpsg").':</th>
							<td>
								<input type="text" name="neu[name]" value="" style="width:300px;" />
							</td>		
							<td>
								<input type="text" name="neu[rabgeb]" value="" />
							</td>
							<td></td>
						</tr>
			'; $content .= '
					</table>
				</td></tr>				
			'; return $content; } public function settings_save() { if ($_REQUEST['neu']['name'] != "") { $this->controller->db->ImportQuery($this->controller->tbl_zv, array( "name" => $_REQUEST['neu']['name'], "rabgeb" => $_REQUEST['neu']['rabgeb'] )); } foreach ($_REQUEST['zv'] as $zv_id => $zv) { $this->controller->db->UpdateQuery($this->controller->tbl_zv, array( "name" => $zv['name'], "rabgeb" => $zv['rabgeb'] ), "`id` = '".wpsg_q($zv_id)."'"); } foreach ($_REQUEST['del'] as $zv_id => $value) { if ($value == "1") { $this->controller->db->Query("
						DELETE FROM `".$this->controller->tbl_zv."` WHERE `id` = '".wpsg_q($zv_id)."'
					"); } } } public function install() { require_once(ABSPATH.'wp-admin/includes/upgrade.php'); $sql = "CREATE TABLE ".$this->controller->tbl_zv." (
		   		id mediumint(9) NOT NULL AUTO_INCREMENT,
		   		name varchar(255) NOT NULL,
		   		rabgeb varchar(255) NOT NULL, 
		   		UNIQUE KEY id (id)
		   	);"; dbDelta($sql); } public function addPayment(&$arPayment, &$basket) { $arZV = $this->controller->db->fetchAssoc("SELECT * FROM `".$this->controller->tbl_zv."` "); $id_modul = $this->id; foreach ($arZV as $zv) { $arPayment[$id_modul.'_'.$zv['id']] = array( "id" => $id_modul.'_'.$zv['id'], "text_clear" => $zv['name'], "text" => $zv['name'], "rabgeb" => preg_replace("/,/", ".", $zv['rabgeb']) ); $rabgb = preg_replace("/,/", ".", $zv['rabgeb']); $this->id = $id_modul."_".$zv['id']; $this->addRabGeb($arPayment, $rabgb, $basket); } $this->id = $id_modul; } } ?>